/**********************************************************************

	--- Qt Architect generated file ---

	File: GfCommentsWin.cpp
	Last generated: Sat Jul 3 17:02:32 1999

 *********************************************************************/

#include "GfCommentsWin.h"
#include "../gfutil.h"

#define Inherited GfCommentsWinData

GfCommentsWin::GfCommentsWin
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
	// this constructor is private bacause it won't work.
}

GfCommentsWin::GfCommentsWin
(
	GfFile *gff
)
	:
	Inherited( NULL, NULL )
{
	setCaption( "Comments" );
	
	gfcomments = gff->comments();
	
	gffile = gff;
	
	init();
}

void GfCommentsWin::init()
{
int numc,i;
char temp[50];

	dvalid = new QDoubleValidator(1.e36,-1.e36,6,this);
	ivalid = new QIntValidator(0,100,this);

	numc = gfcomments.numComments();
	
	if(numc == 0)
	{
		commentnumber_combobox->setEnabled(FALSE);
		comment_lineedit->setEnabled(FALSE);
		row_lineedit->setEnabled(FALSE);
		column_lineedit->setEnabled(FALSE);
		font_combobox->setEnabled(FALSE);
		fontsize_lineedit->setEnabled(FALSE);
		color_combobox->setEnabled(FALSE);
		update_button->setEnabled(FALSE);
		delete_button->setEnabled(FALSE);
	}
	else
	{
		commentnumber_combobox->setEnabled(TRUE);
		comment_lineedit->setEnabled(TRUE);
		row_lineedit->setEnabled(TRUE);
		column_lineedit->setEnabled(TRUE);
		font_combobox->setEnabled(TRUE);
		fontsize_lineedit->setEnabled(TRUE);
		color_combobox->setEnabled(TRUE);
		update_button->setEnabled(TRUE);
		delete_button->setEnabled(TRUE);
	}
	
	for(i=0;i<NUM_PSCOLORS;i++)
	{
		color_combobox->insertItem(pscolors[i]);
	}
	
	for(i=0;i<NUM_PSFONTS;i++)
	{
		font_combobox->insertItem((psfont[i]+1));
	}		

	fontsize_lineedit->setValidator(dvalid);

	for(i=0;i<numc;i++)
	{
		sprintf(temp,"%i",i+1);
		commentnumber_combobox->insertItem(temp);
	}
	
	if(numc > 0)
	{
		commentnumber_combobox->setCurrentItem(0);
	
		setComment(0);
	}
	
}


GfCommentsWin::~GfCommentsWin()
{
	delete dvalid;
	delete ivalid;
}


void GfCommentsWin::addButton()
{
int numc;
char temp[50];
	
	gfcomments.addComment("(blank)",20,2,LOCATION_ROWCOL);

	numc = gfcomments.numComments();
	
	if(numc == 1)
	{
		commentnumber_combobox->setEnabled(TRUE);
		comment_lineedit->setEnabled(TRUE);
		row_lineedit->setEnabled(TRUE);
		column_lineedit->setEnabled(TRUE);
		font_combobox->setEnabled(TRUE);
		fontsize_lineedit->setEnabled(TRUE);
		color_combobox->setEnabled(TRUE);
		update_button->setEnabled(TRUE);
		delete_button->setEnabled(TRUE);
	}
	
	sprintf(temp,"%i",numc);
	commentnumber_combobox->insertItem(temp);

	commentnumber_combobox->setCurrentItem(numc-1);
	
	setComment(0);
	
	gffile->setComments(gfcomments);
	
	emit commentsChanged();
}

void GfCommentsWin::dismissButton()
{
	done(0);

}

void GfCommentsWin::deleteButton()
{
int nc;

	nc=commentnumber_combobox->currentItem();
	
	gfcomments.removeComment(nc);
	
	commentnumber_combobox->removeItem(commentnumber_combobox->count()-1);

	if(gfcomments.numComments() == 0)
	{
		commentnumber_combobox->setEnabled(FALSE);
		comment_lineedit->setEnabled(FALSE);
		row_lineedit->setEnabled(FALSE);
		column_lineedit->setEnabled(FALSE);
		font_combobox->setEnabled(FALSE);
		fontsize_lineedit->setEnabled(FALSE);
		color_combobox->setEnabled(FALSE);
		update_button->setEnabled(FALSE);
		delete_button->setEnabled(FALSE);
	}
	else
	{
		commentnumber_combobox->setCurrentItem(0);
		setComment(0);
	}
	
	gffile->setComments(gfcomments);
	
	emit commentsChanged();
}

void GfCommentsWin::updateButton()
{
	changeComment();
}

void GfCommentsWin::changeComment()
{
int nc,loctype;

	nc=commentnumber_combobox->currentItem();
	
	if(nc < 0) return;
	
	if(rowcol_radiobutton->isChecked() == TRUE)
	{
		loctype = LOCATION_ROWCOL;
	}
	else
	{
		loctype = LOCATION_DATA;
	}
	
	gfcomments.setComment(nc,comment_lineedit->text(),
		atof(column_lineedit->text()),atof(row_lineedit->text()),
		loctype);
		
	gfcomments.setColor(nc,color_combobox->currentItem());
	gfcomments.setFont(nc,font_combobox->currentItem());
	gfcomments.setFontSize(nc,atof(fontsize_lineedit->text()));
	
	gffile->setComments(gfcomments);
	
	emit commentsChanged();

}

void GfCommentsWin::setComment(int)
{
char *comment;
int nc;
char text[50];

	nc=commentnumber_combobox->currentItem();
	
	if(nc < 0) return;
	
	strmalloc(&comment,gfcomments.commentLen(nc));
	gfcomments.comment(nc,comment);
	
	comment_lineedit->setText(comment);
	free(comment);
	
	if(gfcomments.locationType(nc) == LOCATION_ROWCOL)
	{
		rowcol_radiobutton->setChecked(TRUE);
		row_lineedit->setValidator(ivalid);
		column_lineedit->setValidator(ivalid);
	}
	else
	{
		data_radiobutton->setChecked(TRUE);
		row_lineedit->setValidator(dvalid);
		column_lineedit->setValidator(dvalid);
	}
	
	sprintf(text,"%g",gfcomments.locationY(nc));
	row_lineedit->setText(text);
	sprintf(text,"%g",gfcomments.locationX(nc));
	column_lineedit->setText(text);
	sprintf(text,"%g",gfcomments.fontSize(nc));
	fontsize_lineedit->setText(text);	

	font_combobox->setCurrentItem(gfcomments.font(nc));
	color_combobox->setCurrentItem(gfcomments.color(nc));		

}

void GfCommentsWin::locationTypeChanged()
{

	if(rowcol_radiobutton->isChecked())
	{		
		row_lineedit->setValidator(ivalid);
		column_lineedit->setValidator(ivalid);
	}
	else
	{
		row_lineedit->setValidator(dvalid);
		column_lineedit->setValidator(dvalid);
	}
}
