#include "gfcommon.h"
#include <qfile.h>

#ifndef GFPLOTDEFSH
#define GFPLOTDEFSH


class GfPlotDefs
{

public:


	GfPlotDefs();
	
	GfPlotDefs(const GfPlotDefs &); // copy constructor
	GfPlotDefs(const GfPlotDefs *); // ditto
    
	virtual ~GfPlotDefs();
    
	int setRotatePlot(int );
	int setEncapsulated(int );
	int setPlotName(const char *);
	int setPSJoin(int );
	int setFontSize(float );
	int setSymbolSize(float );
	int setArrowSize(float );
	int setPlotSize(float, float ); // x,y sizes
	
	int setCurvesVisibility(int );
	int setCommentsVisibility(int );
	int setAxesVisibility(int );
	
	int setFont(int ); // for axes
	int setColor(int);

	int rotatePlot() const ;
	int encapsulated() const ;
	void plotName(char *) const ;
	int plotNameLen() const ;
	int psJoin() const ;
	float fontSize() const ;
	float symbolSize() const ;
	float arrowSize() const ;
	float xPlotSize() const ;
	float yPlotSize() const ;
	
	int curvesVisible() const ;
	int commentsVisible() const ;
	int axesVisible() const ;

	int font() const ;
	int color() const ;
	
	int defaults();
	
	void print(OSTREAM *);
	int readFormat(QFile *in,char *line);
	
	void operator=(const GfPlotDefs &); // assignment operator


private:


	int rotp;
	int encap;

	char *plot_name;
    
	int psjoin; /* 0 = miter 1=round 2=bevel joins in ps output */
    
	float symbol_size;
    
	float font_size; // font size
    
	float arrow_size; 
	        
	float x_plot_size;      /* plot  sizes */
	float y_plot_size;      /* plot  sizes */

	int plot_axes; /* 1 = yes 0 = no */
	int plot_comments; /* 1 = yes 0 = no */
	int plot_curves; /* 1 = yes 0 = no */
	
	int axes_font;
	
	int axes_color;
	
	void init();
	
};

OSTREAM &operator<<(OSTREAM &os, GfPlotDefs *m);
OSTREAM &operator<<(OSTREAM &os, GfPlotDefs &m);


#endif
