/**********************************************************************

	--- Qt Architect generated file ---

	File: GfWindow.cpp
	Last generated: Thu Jun 17 21:22:04 1999

 *********************************************************************/
#define GFWINMAIN
#include "GfWindow.h"
#include <qcolor.h>
#include <qmessagebox.h>
#include <qkeycode.h>
#include "../version.h"
#include <qclipboard.h>

#define MENUHEIGHT 25

#define Inherited GfWindowData

GfWindow::GfWindow
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
#ifndef UNIX
	setStyle(WindowsStyle);
#else
	setStyle(MotifStyle);
#endif

	resize(gfwin_width,gfwin_height);

	menu->setMaximumHeight(2*MENUHEIGHT);
	menu->resize(width(),MENUHEIGHT);

	gfwidget->setBackgroundColor(white); 
	
	gfwidget->move(0,menu->height());
	gfwidget->resize(width(),height()-menu->height());
	
	if(! gfwidget->fileName().isEmpty())
	{
		setCaption(gfwidget->fileName());
	}
	else
	{
		setCaption("Gf");
	}
	
	connect(gfwidget,SIGNAL(fileChanged()),this,SLOT(updateFileChange()));
	connect(gfwidget,SIGNAL(popupQuit(int)),this,SLOT(quit(int)));
	
	connect(gfwidget,SIGNAL(pointClicked(int,int)),this,SLOT(pointSelected(int,int)));

	connect(this,SIGNAL(editChanged()),mainwin,SLOT(changedEdit()));
	connect(mainwin,SIGNAL(editChanged()),this,SLOT(changedEdit()));

	//QPopupMenu *file=new QPopupMenu();
	QPopupMenu *file;
	file = gfwidget->filePopupMenu();
	
	file->insertItem("New...",this,SLOT(newWindow()),CTRL+Key_N,-1,0);
	menu->insertItem("File",file);
	
	edit = new QPopupMenu();
	cut_item=edit->insertItem("Cut",this,SLOT(cut()),CTRL+Key_X);
	copy_item=edit->insertItem("Copy",this,SLOT(copy()),CTRL+Key_C);
	paste_item=edit->insertItem("Paste",this,SLOT(paste()),CTRL+Key_V);
	edit->insertSeparator();
	stats_item=edit->insertItem("Selection Stats...",this,SLOT(selectionStats()));
	
	menu->insertItem("Edit",edit);
	
	edit->setItemEnabled(cut_item,FALSE);
	edit->setItemEnabled(copy_item,FALSE);
	edit->setItemEnabled(stats_item,FALSE);
	if(have_paste_data == GF_NO)
		edit->setItemEnabled(paste_item,FALSE);
		
	edit->insertItem("Data...",gfwidget,SLOT(editCurves()));
	
	QPopupMenu *settings;
	settings = gfwidget->settingsPopupMenu(); // disables widget popup
	menu->insertItem("Settings",settings);
	
	menu->insertSeparator();
	
	QPopupMenu *help=new QPopupMenu();
	help->insertItem("Version",this,SLOT(version()));
	menu->insertItem("Help",help);
		
	
	num_gf_windows++;
}


GfWindow::~GfWindow()
{
}


void GfWindow::setGfFile(GfFile &gff)
{
	gfwidget->setGfFile(gff);
	
	setCaption(gfwidget->fileName());
}

void GfWindow::resizeEvent(QResizeEvent *)
{
	gfwidget->move(0,menu->height());
	gfwidget->resize(width(),height()-menu->height());
	gfwin_width=width();
	gfwin_height=height();
}

void GfWindow::updateFileChange()
{
	emit fileChanged();
	
	resetSelection(); 
	
	setCaption(gfwidget->fileName());
}

void GfWindow::open()
{
	gfwidget->open();
	show();
}

int GfWindow::read(QFile *qf,int xcol,int ycol,int append)
{
	return(gfwidget->read(qf,xcol,ycol,append));
}

void GfWindow::version()
{
	QString qs("GfQt by Tom Shield\nVersion: ");
	qs.append(VERSION);
	QMessageBox mb("Gf",qs,QMessageBox::NoIcon,
		QMessageBox::Ok | QMessageBox::Default,0,0,this);
		
	mb.exec();
}

void GfWindow::quit(int mode)
{
	if(mode == 1 && num_gf_windows > 1)
	{
		QMessageBox mb("Gf","Close all Windows and Quit?",QMessageBox::NoIcon,
			QMessageBox::Yes,QMessageBox::No | QMessageBox::Default,0,this);
			
		switch(mb.exec())
		{
			case QMessageBox::Yes:
				qApp->quit();
			break;
				
			default:
				return;
			break;
		}
	}
	
	num_gf_windows--;
	
#ifdef DEBUG1
	cout <<"num_gf_windows:"<<num_gf_windows<<"\n";
#endif	
	if(num_gf_windows == 0 )
	{
#ifdef DEBUG1
		cout <<"doing qApp->quit()\n";
#endif		
		qApp->quit();
	}

	done(0);
}

void GfWindow::newWindow()
{
	GfWindow *newgf;
	newgf = new GfWindow();
	newgf->show();  // should this be open or show? 
}


int GfWindow::checkNumCols(QFile *qf)
{
	return(gfwidget->checkNumCols(qf));
}

void GfWindow::pointSelected(int curve,int point)
{
#ifdef DEBUG1
	cout << "curve,point = "<<curve<<" , "<<point<<"\n";
#endif	

	switch(select_status)
	{
		default:
		case SELECTED_NONE:
			start.curve = curve;
			start.point = point;
			select_status = SELECTED_FIRST;
			gfwidget->setSelection(start.curve,SEG_ONE_POINT,start.point);
			gfwidget->repaint();
		break;
		case SELECTED_FIRST:
			if(start.curve == curve)
			{
				end.curve = curve;
				if(start.point < point)
				{
					end.point = point;
				}
				else
				{
					end.point = start.point;
					start.point = point;
				}
				if(start.point == end.point) // select all
				{
					start.point = SEG_WHOLE_CURVE;
					end.point = 0;
				}
				select_status = SELECTED_SECOND;
				edit->setItemEnabled(cut_item,TRUE);
				edit->setItemEnabled(copy_item,TRUE);
				edit->setItemEnabled(stats_item,TRUE);
				gfwidget->setSelection(start.curve,start.point,end.point);
				gfwidget->repaint();
			}
		break;
		case SELECTED_SECOND:
			resetSelection();
		break;
		
	}
	
}
void GfWindow::resetSelection()
{
	select_status = SELECTED_NONE;
	edit->setItemEnabled(cut_item,FALSE);
	edit->setItemEnabled(copy_item,FALSE);
	edit->setItemEnabled(stats_item,FALSE);
	gfwidget->setSelection(-1,0,0);
	gfwidget->erase();
	gfwidget->repaint();
}


void GfWindow::cut()
{
	paste_curve=gfwidget->curveSegment(start.curve,start.point,end.point);
	
	if(paste_curve.numPoints() > 0)
	{
		edit->setItemEnabled(paste_item,TRUE);
		have_paste_data = GF_YES;
		emit editChanged();
		
		QClipboard *cb = QApplication::clipboard();
		
		QString text;
		QTextStream ts(text,IO_WriteOnly );
		paste_curve.print(&ts);
		
		cb->setText(text);
		
		paste_scale = gfwidget->scale();
		
		gfwidget->deleteCurveSegment(start.curve,start.point,end.point);
	}
	else
	{
		edit->setItemEnabled(paste_item,FALSE);
		have_paste_data = GF_NO;
		emit editChanged();
	}
		
	
	resetSelection();
}

void GfWindow::copy()
{
	paste_curve=gfwidget->curveSegment(start.curve,start.point,end.point);
	
	if(paste_curve.numPoints() > 0)
	{
		edit->setItemEnabled(paste_item,TRUE);
		have_paste_data = GF_YES;
		emit editChanged();
		
		QClipboard *cb = QApplication::clipboard();
		
		QString text;
		QTextStream ts(text,IO_WriteOnly );
		paste_curve.print(&ts);
		
		cb->setText(text);
		
		paste_scale = gfwidget->scale();
	}
	else
	{
		edit->setItemEnabled(paste_item,FALSE);
		have_paste_data = GF_NO;
		emit editChanged();
	}

}

void GfWindow::paste()
{
	if(have_paste_data == GF_YES)
	{
		gfwidget->appendCurve(&paste_curve,paste_scale);
	
		gfwidget->repaint();
		
		// only allow same data to be pasted once.
		edit->setItemEnabled(paste_item,FALSE);
	}

}

void GfWindow::changedEdit()
{
	if(have_paste_data == GF_YES)
	{
		edit->setItemEnabled(paste_item,TRUE);
	}
	else
	{
		edit->setItemEnabled(paste_item,FALSE);
	}
}	

void GfWindow::selectionStats()
{
int n,have_fit;
float slope,intercept,xmax,ymax,xmin,ymin,xave,yave;

	if(select_status == SELECTED_SECOND)
	{
		paste_curve=gfwidget->curveSegment(start.curve,start.point,end.point);
		
		n = paste_curve.numPoints();
		
		if(paste_curve.linearFit(&slope,&intercept) == GF_OK)
		{
			have_fit = GF_YES;
		}
		else
		{
			have_fit = GF_NO;
		}

		paste_curve.getMaxMin(&xmax,&xmin,&ymax,&ymin);
		paste_curve.getAverages(&xave,&yave);
		
		QString text,msg;
		
		text.sprintf("Number of Points = %i\n",n);
		msg.append(text);
		text.sprintf("X max = %g\nX min = %g\n",xmax,xmin);
		msg.append(text);
		text.sprintf("\tAverage X = %g\n",xave);
		msg.append(text);
		text.sprintf("Y max = %g\nY min = %g\n",ymax,ymin);
		msg.append(text);
		text.sprintf("\tAverage Y = %g\n",yave);
		msg.append(text);
		
		if(have_fit == GF_YES)
		{
			text.sprintf("Linear Fit:\n\t Y = %g X + %g\n",slope,intercept);
		}
		else
		{
			text.sprintf("Linear Fit:\n\tnot possible\n");
		}
		msg.append(text);
		
		QMessageBox mb("Selection Statistics",msg,QMessageBox::Information,
			QMessageBox::Ok | QMessageBox::Default,0,0,this);
			
		mb.exec();
		
		if(have_fit == GF_YES)
		{
			QMessageBox mb2("Linear Fit","Append Linear fit as new Curve?",
				QMessageBox::NoIcon,QMessageBox::Yes, 
				QMessageBox::No | QMessageBox::Default,0,this);
				
			switch(mb2.exec())
			{
				case QMessageBox::Yes: 
				{				
					GfCurve c_linfit;
					
					float xmax,ymax,ymin,xmin,y;
					
					gfwidget->getMaxMin(start.curve,&xmax,&xmin,&ymax,&ymin);
					
					y = slope*xmin+intercept;
					
					c_linfit.appendPoint(0,xmin,y);
					
					y = slope*xmax+intercept;
					
					c_linfit.appendPoint(1,xmax,y);
					
					gfwidget->appendCurve(&c_linfit,paste_scale);
					
					gfwidget->repaint();
				}
				break;
				
				default:
				case QMessageBox::No: 
				
				break;
			}
		}

	}
}

void gfInitMainWin(int in_gf)
{

	if(in_gf == 1)
	{
		num_gf_windows = 0;
	
		gfwin_height = 400;
		gfwin_width = 500;
	
		mainwin = new GfMainWidget();
		
		mainwin->resize(gfwin_width,gfwin_height);
	
		qApp->setMainWidget(mainwin);
		
		gfwin_width = mainwin->width();
		gfwin_height = mainwin->height();
	}
	else		
	{
		num_gf_windows = 1; // so close does not quit
	
		gfwin_height = 400;
		gfwin_width = 500;
	
		mainwin = new GfMainWidget();
		
		mainwin->resize(gfwin_width,gfwin_height);
	}

}
