/**********************************************************************

	--- Qt Architect generated file ---

	File: GfWindow.h
	Last generated: Thu Jun 17 21:22:04 1999

 *********************************************************************/

#ifndef GfWindow_included
#define GfWindow_included

// values of select_status
#define SELECTED_NONE 0
#define SELECTED_FIRST 1
#define SELECTED_SECOND 2

struct Selection{
	int curve;
	int point;
};

#include "GfWindowData.h"
#include "../gfcommon.h"
#include "../gfcurve.h"
#include "../gfscale.h"
#include "../mainwidget.h"



// counter for number of windows open.

#ifdef GFWINMAIN
	int num_gf_windows;
	int gfwin_width,gfwin_height;
	int have_paste_data;
	GfCurve paste_curve;
	GfScale paste_scale;
	GfMainWidget *mainwin;
#else
	extern int num_gf_windows;
	extern int gfwin_width,gfwin_height;
	extern int have_paste_data;
	extern GfCurve paste_curve;
	extern GfScale paste_scale;
	extern GfMainWidget *mainwin;
#endif

class GfWindow : public GfWindowData
{
    Q_OBJECT

public:

    GfWindow
    (
        QWidget* parent = NULL,
        const char* name = NULL
    );

    virtual ~GfWindow();
    
    void setGfFile(GfFile &gff);
    
public slots:
	void updateFileChange();
	void open();
	int read(QFile *,int,int,int append=GF_NO);
	void quit(int);
	void newWindow();
	int checkNumCols(QFile *);
	void version();
	void pointSelected(int,int);
	void cut();
	void copy();
	void paste();
	void changedEdit();
	void selectionStats();

signals:
	void fileChanged();
	void editChanged();
    
private:

	void resizeEvent(QResizeEvent *);
	
	int select_status; 
	
	struct Selection start;
	struct Selection end;
	
	void resetSelection();
	
	QPopupMenu *edit;
	int cut_item,copy_item,paste_item,stats_item;

};

// helper function to call to set up window global variables.
// only gf should call this with an arguement.

void gfInitMainWin(int in_gf = 0);


#endif // GfWindow_included
